84eddbc1e36a2277e867282eb546fc08966b2ad7
[darcs-mirror-metainit.git] / utils / create-sysvinit-file
1 #!/usr/bin/perl -w
2 #
3 # Creates a sysvinit file from a metainit description.
4 #
5
6 use MetaInit::Parse;
7
8 $filename = shift || die "Useage: $0 <filename>\n";
9 my $output = shift;
10
11 # Parse the metainit in
12 %initparams = %{MetaInit::Parse::parse({ filename => $filename })};
13
14 if ($output) {
15     open(STDOUT,'>',$output) or die "Can't open '$output': $!";
16 }
17
18 # Print the "dynamic" part of the initscript
19
20 my $rl_start = join " ", @{$initparams{"Start-Levels"}};
21 my $rl_stop  = join " ", @{$initparams{"Stop-Levels"}};
22
23 print << "EOF";
24 #! /bin/sh
25 #
26 # This a generated file. DO NOT EDIT THIS FILE!
27 # If you want to modify how this file works, please
28 # modify $filename and re-run update-metainit.
29 #
30 # If you are sure that you want to modify this file,
31 # remove this comment, and update-metainit will not override
32 # this script any more.
33 #
34 ### BEGIN INIT INFO
35 # Provides:          $initparams{"Name"}
36 # Default-Start:     $rl_start
37 # Default-Stop:      $rl_stop
38 # Short-Description: $initparams{"Short-Description"}
39 EOF
40
41 print "# Required-Start:   " . join(" ",@{$initparams{"Required-Start"}}) . "\n";
42 print "# Required-Stop:     " . join(" ",@{$initparams{"Required-Stop"}}) . "\n";
43 print "# Description:       ";
44 print join("\n#                    ",split("\n",$initparams{"Description"})). "\n";
45 print "\n";
46
47 # prevent quoted strings from breaking the generated script:
48
49 my %quoted_initparams;
50
51 while (my ($k, $v) = each %initparams){
52     $quoted_initparams{$k} = quotemeta ($v || '');
53 }
54
55 print << "EOF"
56 ### END INIT INFO
57
58 # PATH should only include /usr/* if it runs after the mountnfs.sh script
59 PATH=/sbin:/usr/sbin:/bin:/usr/bin
60 DESC=$quoted_initparams{"Short-Description"}
61 NAME=$quoted_initparams{"Name"}
62 DAEMON=$initparams{"Path"}
63 BASENAME=$initparams{"Basename"}
64 DAEMON_ARGS=$quoted_initparams{"Args"}
65 PIDFILE=/var/run/\$NAME.pid
66 SCRIPTNAME=/etc/init.d/\$NAME
67 EOF
68 ;
69
70 # ... and the rest of the initscript, that is identical for all
71 # metainit-created scripts.
72 print << 'EOF'
73 # Exit if the package is not installed
74 [ -x "$DAEMON" ] || exit 0
75
76 # Read configuration variable file if it is present
77 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
78
79 # Load the VERBOSE setting and other rcS variables
80 . /lib/init/vars.sh
81
82 # Define LSB log_* functions.
83 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
84 . /lib/lsb/init-functions
85
86 #
87 # Function that starts the daemon/service
88 #
89 do_start()
90 {
91 EOF
92 ;
93
94 if($initparams{"Prestart-Hook"}) {
95     print "\t" . join("\n\t",split("\n",$initparams{"Prestart-Hook"}));
96     print "\n";
97 }
98
99 print << 'EOF'
100         # Return
101         #   0 if daemon has been started
102         #   1 if daemon was already running
103         #   2 if daemon could not be started
104         start-stop-daemon --start --background --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
105                 || return 1
106         start-stop-daemon --start --background --quiet --make-pidfile --pidfile $PIDFILE --exec $DAEMON -- \
107                 $DAEMON_ARGS \
108                 || return 2
109         # Add code here, if necessary, that waits for the process to be ready
110         # to handle requests from services started subsequently which depend
111         # on this one.  As a last resort, sleep for some time.
112 }
113
114 #
115 # Function that stops the daemon/service
116 #
117 do_stop()
118 {
119         # Return
120         #   0 if daemon has been stopped
121         #   1 if daemon was already stopped
122         #   2 if daemon could not be stopped
123         #   other if a failure occurred
124         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $BASENAME
125         RETVAL="$?"
126
127         rm -f $PIDFILE
128
129         return $RETVAL
130 EOF
131 ;
132
133 if($initparams{"Poststop-Hook"}) {
134     print "\t" . join("\n\t",split("\n",$initparams{"Poststop-Hook"}));
135     print "\n";
136 }
137
138 print << 'EOF';
139         return "$RETVAL"
140 }
141
142 #
143 # Function that sends a SIGHUP to the daemon/service
144 #
145 do_reload() {
146         #
147         # If the daemon can reload its configuration without
148         # restarting (for example, when it is sent a SIGHUP),
149         # then implement that here.
150         #
151         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
152         return 0
153 }
154
155 case "$1" in
156   start)
157         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
158         do_start
159         case "$?" in
160                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
161                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
162         esac
163         ;;
164   stop)
165         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
166         do_stop
167         case "$?" in
168                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
169                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
170         esac
171         ;;
172   #reload|force-reload)
173         #
174         # If do_reload() is not implemented then leave this commented out
175         # and leave 'force-reload' as an alias for 'restart'.
176         #
177         #log_daemon_msg "Reloading $DESC" "$NAME"
178         #do_reload
179         #log_end_msg $?
180         #;;
181   restart|force-reload)
182         #
183         # If the "reload" option is implemented then remove the
184         # 'force-reload' alias
185         #
186         log_daemon_msg "Restarting $DESC" "$NAME"
187         do_stop
188         case "$?" in
189           0|1)
190                 do_start
191                 case "$?" in
192                         0) log_end_msg 0 ;;
193                         1) log_end_msg 1 ;; # Old process is still running
194                         *) log_end_msg 1 ;; # Failed to start
195                 esac
196                 ;;
197           *)
198                 # Failed to stop
199                 log_end_msg 1
200                 ;;
201         esac
202         ;;
203   *)
204         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
205         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
206         exit 3
207         ;;
208 esac
209 EOF
210
211 if ($output) {
212     close STDOUT;
213     chmod 0755, $output or die "Can't change permissions for '$output': $!";
214 }
215
216 # vim: ts=4:sw=4:expandtab